unit main;

interface

// Copy from Src to Dest as many as Count bytes
procedure Move(Src,Dest: Pointer; Count: Word);
// Fill Dest with B as many as Count bytes
procedure FillByte(Dest: Pointer; const B: Byte; Count: Word);
// Fill Dest with W as many as Count bytes
procedure FillWord(Dest: Pointer; const W: Word; Count: Word);
// Return PChar length
function StrLen(const P: PChar): LongWord;
// Write Value to port Port
procedure WritePort(Port: LongInt; Value: Byte);
// Read Value from port Port
function ReadPort(Port: LongInt): Byte;

implementation

procedure Move(Src,Dest: Pointer; Count: Word);
var
  sp,dp: PByte;
begin
//{
  // Assembler way
  asm
    mov esi,Src
    mov edi,Dest
    cld
    mov ecx,Count
    rep movsb
  end;
//}
{
  // Pascal way
  sp:=PByte(Src);
  dp:=PByte(Dest);
  while Count>0 do begin
    dp^:=sp^;
    Inc(dp);
    Inc(sp);
    Dec(Count);
  end;
}
end;

procedure FillByte(Dest: Pointer; const B: Byte; Count: Word);
var
  dp: PByte;
begin
  dp:=PByte(Dest);
  while Count>0 do begin
    dp^:=B;
    Inc(dp);
    Dec(Count);
  end;
end;

procedure FillWord(Dest: Pointer; const W: Word; Count: Word);
var
  dp: PWord;
begin
  dp:=PWord(Dest);
  while Count>0 do begin
    dp^:=W;
    Inc(dp);
    Dec(Count);
  end;
end;

function StrLen(const P: PChar): LongWord;
var
  temp: PChar;
begin
  StrLen:=0;
  temp:=P;
  while temp^<>#0 do begin
    Inc(StrLen);
    Inc(temp);
  end;
end;

procedure WritePort(Port: LongInt; Value: Byte);
begin
  asm
    mov edx,port
    mov al,value
    out dx,al
  end ['EAX','EDX'];
end;

function ReadPort(Port: LongInt): Byte;
var
  value: Byte;
begin
  asm
    mov edx,port
    in  al,dx
    mov edx,value
    mov [edx],al
  end ['EAX','EDX'];
  ReadPort:=value;
end;

end.
