unit screen;

interface

uses
  main;

var
  VidMem: PChar;
  CursorPosX,CursorPosY: Word;
  Attrib: Word;
  Blank: Word;

procedure Init;
procedure Scroll;
procedure MoveCursor;
procedure ClearScreen;
procedure WriteChr(const c: Char);
procedure WriteStr(const P: PChar);
procedure WriteStrLn(const P: PChar);
procedure SetTextColor(const BackColor,ForeColor: Byte);

implementation

procedure Init;
begin
  VidMem:=PChar($b8000);
  CursorPosX:=0;
  CursorPosY:=0;
  Attrib:=$0F;
  Blank:=$20 or (Attrib shl 8);
end;

procedure Scroll;
var
  dest: PChar;
begin
  if CursorPosY>=25 then begin
    dest:=VidMem+2*80;
    Move(dest,VidMem,24*160);
    dest:=VidMem+24*160;
    FillWord(dest,Blank,80);
    CursorPosY:=24;
  end;
end;

procedure MoveCursor;
var
  temp: Word;
begin
  temp:=CursorPosY*80+CursorPosX;
  WritePort($3D4,14);
  WritePort($3D5,temp shr 8);
  WritePort($3D4,15);
  WritePort($3D5,temp);
end;

procedure ClearScreen;
var
  i: Word;
begin
  for i:=0 to 3999 do
    VidMem[i]:=#0;
  CursorPosX:=0;
  CursorPosY:=0;
  MoveCursor;
end;

procedure WriteChr(const c: Char);
var
  offset: Word;
begin
  case c of
    #08: if CursorPosX<>0 then Dec(CursorPosX);
    #09: Inc(CursorPosX,8);
    #13: CursorPosX:=0;
    #10: Inc(CursorPosY);
    #32..#255: begin
      offset:=(CursorPosX shl 1)+(CursorPosY*160);
      VidMem[offset]:=c;
      Inc(offset);
      VidMem[offset]:=Char(Attrib);
      Inc(CursorPosX);
    end;
  end;
  if CursorPosX>=80 then begin
    CursorPosX:=0;
    Inc(CursorPosY);
  end;
  Scroll;
  MoveCursor;
end;

procedure WriteStr(const P: PChar);
var
  i: LongWord;
begin
  i:=0;
  while P[i]<>#0 do begin
    WriteChr(P[i]);
    Inc(i);
  end;
end;

procedure WriteStrLn(const P: PChar);
begin
  WriteStr(P);
  WriteStr(#13#10);
end;

procedure SetTextColor(const BackColor,ForeColor: Byte);
begin
  Attrib:=(BackColor shl 4) or (ForeColor and $0F)
end;

end.
